/*---------------------------------------------------------------------------------
	$Id: template.c,v 1.4 2005/09/17 23:15:13 wntrmute Exp $

	Basic Hello World

	$Log: template.c,v $
	Revision 1.4  2005/09/17 23:15:13  wntrmute
	corrected iprintAt in templates
	
	Revision 1.3  2005/09/05 00:32:20  wntrmute
	removed references to IPC struct
	replaced with API functions
	
	Revision 1.2  2005/08/31 01:24:21  wntrmute
	updated for new stdio support

	Revision 1.1  2005/08/03 06:29:56  wntrmute
	added templates


---------------------------------------------------------------------------------*/
#include "nds.h"
#include <nds/arm9/console.h>
#include <nds/arm9/input.h>
#include <stdio.h>

#define  MIDI_DATA_MAX_SIZE  256

uint8 midi_data[MIDI_DATA_MAX_SIZE];
uint16 midi_data_size;
vuint16 midi_data_index;

void fifo_transmit_handler(void) {
	uint16 index;
	if (midi_data_index == midi_data_size)
		return;
	index = midi_data_index;
	midi_data_index++;
	REG_IPC_FIFO_TX = (uint32) midi_data[index];
}

int midi_send(void) {
	if (midi_data_size <= 0)
		return 0;
	midi_data_index = 1;
	REG_IPC_FIFO_TX = (uint32) midi_data[0];
	return 1;
}

int main(void) {
	touchPosition touchXY;
	uint32 prev_keys = 0, keys = 0;

	irqInit();
	videoSetMode(0);	//not using the main screen
	videoSetModeSub(MODE_0_2D | DISPLAY_BG0_ACTIVE); //sub bg 0 will be used to print text
	vramSetBankC(VRAM_C_SUB_BG);
	SUB_BG0_CR = BG_MAP_BASE(31);
	BG_PALETTE_SUB[255] = RGB15(31, 31, 31); //by default font will be rendered with color 255
	//consoleInit() is a lot more flexible but this gets you up and running quick
	consoleInitDefault((u16*)SCREEN_BASE_BLOCK_SUB(31), (u16*)CHAR_BASE_BLOCK_SUB(0), 16);
	REG_IPC_FIFO_CR = IPC_FIFO_ENABLE | IPC_FIFO_SEND_IRQ;
	irqSet(IRQ_FIFO_EMPTY, fifo_transmit_handler);
	irqEnable(IRQ_FIFO_EMPTY);
	iprintf("\n\n\tMIDI OUT Test v1.07\n");
	while(1) {
		scanKeys();
		keys = keysHeld();
		touchXY = touchReadXY();
		iprintf("\x1b[10;0HTouch x = %04X, %04X\n", touchXY.x, touchXY.px);
		iprintf("Touch y = %04X, %04X\n", touchXY.y, touchXY.py);
		iprintf("keysHeld = %08X\n", keys);
		if (prev_keys != keys) {
			if (keys & KEY_A) {
				/* note on */
				midi_data[0] = 0x91;
				midi_data[1] = 0x40;
				midi_data[2] = 0x7F;
				midi_data_size = 3;
				midi_send();
				iprintf("NOTE ON ");
			}
			else if (keys & KEY_B) {
				/* note off */
				midi_data[0] = 0x91;
				midi_data[1] = 0x40;
				midi_data[2] = 0x00;
				midi_data_size = 3;
				midi_send();
				iprintf("NOTE OFF");
			}
			prev_keys = keys;
		}
	}
	return 0;
}
